-- CONSTANTS *************************************************************************************

BarometricAltitude = "BARO"

redMinInterceptSpeed = 950
redMaxInterceptSpeed = 1200

blueCoalition = "blue"

RedBorder = ZONE_POLYGON:NewFromGroupName( "Red Border")
BlueBorder = ZONE_POLYGON:NewFromGroupName( "Blue Border" )

-- FRONTLINE GROUPS SPAWN RED ***************************************************************************************

RedSpawnWest = ZONE:New( "RUS Spawn W")
RedSpawnMidWest = ZONE:New( "RUS Spawn MW")
RedSpawnEast = ZONE:New( "RUS Spawn E")
RedSpawnMidEast = ZONE:New( "RUS Spawn ME")

-- GROUPS Armoured ****

RedArmouredTeamEast = GROUP:FindByName("RUS Armoured Team #1")
RedArmouredTeamEast:InitZone( RedSpawnEast )
RedArmouredTeamEast:InitRandomizePositionZone( true )
RedArmouredTeamEast:HandleEvent( EVENTS.Dead )
function RedArmouredTeamEast:OnEventDead( EventData )
  self:E( { "Size ", Size = RedArmouredTeamEast:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
  if RedArmouredTeamEast:GetSize() == 1 then
    RedArmouredTeamEast:Respawn()
  end
end

RedArmouredTeamMidEast = GROUP:FindByName("RUS Armoured Team #2")
RedArmouredTeamMidEast:InitZone( RedSpawnMidEast )
RedArmouredTeamMidEast:InitRandomizePositionZone( true )
RedArmouredTeamMidEast:HandleEvent( EVENTS.Dead )
function RedArmouredTeamMidEast:OnEventDead( EventData )
  self:E( { "Size ", Size = RedArmouredTeamMidEast:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
  if RedArmouredTeamMidEast:GetSize() == 1 then
    RedArmouredTeamMidEast:Respawn()
  end
end

RedArmouredTeamMidWest = GROUP:FindByName("RUS Armoured Team #3")
RedArmouredTeamMidWest:InitZone( RedSpawnMidWest )
RedArmouredTeamMidWest:InitRandomizePositionZone( true )
RedArmouredTeamMidWest:HandleEvent( EVENTS.Dead )
function RedArmouredTeamMidWest:OnEventDead( EventData )
  self:E( { "Size ", Size = RedArmouredTeamMidWest:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
    if RedArmouredTeamMidWest:GetSize() == 1 then
    RedArmouredTeamMidWest:Respawn()
  end
end

RedArmouredTeamWest = GROUP:FindByName("RUS Armoured Team #4")
RedArmouredTeamWest:InitZone( RedSpawnWest )
RedArmouredTeamWest:InitRandomizePositionZone( true )
RedArmouredTeamWest:HandleEvent( EVENTS.Dead )
function RedArmouredTeamWest:OnEventDead( EventData )
  self:E( { "Size ", Size = RedArmouredTeamWest:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
  if RedArmouredTeamWest:GetSize() == 1 then
    RedArmouredTeamWest:Respawn()
  end
end

-- GROUPS Infantry ****

RedInfantryTeamMidEast = GROUP:FindByName("RUS Infantry Team #2")
RedInfantryTeamMidEast:InitZone( RedSpawnMidEast )
RedInfantryTeamMidEast:InitRandomizePositionZone( true )
RedInfantryTeamMidEast:HandleEvent( EVENTS.Dead )
function RedInfantryTeamMidEast:OnEventDead( EventData )
  self:E( { "Size ", Size = RedInfantryTeamMidEast:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
  if RedInfantryTeamMidEast:GetSize() == 1 then
    RedInfantryTeamMidEast:Respawn()
  end
end

RedInfantryTeamMidWest = GROUP:FindByName("RUS Infantry Team #3")
RedInfantryTeamMidWest:InitZone( RedSpawnMidWest )
RedInfantryTeamMidWest:InitRandomizePositionZone( true )
RedInfantryTeamMidWest:HandleEvent( EVENTS.Dead )
function RedInfantryTeamMidWest:OnEventDead( EventData )
  self:E( { "Size ", Size = RedInfantryTeamMidWest:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
    if RedInfantryTeamMidWest:GetSize() == 1 then
    RedInfantryTeamMidWest:Respawn()
  end
end

-- FRONTLINE GROUPS SPAWN BLUE ***************************************************************************************

BlueSpawnWest = ZONE:New( "GEO Spawn W")
BlueSpawnMidWest = ZONE:New( "GEO Spawn MW")
BlueSpawnEast = ZONE:New( "GEO Spawn E")
BlueSpawnMidEast = ZONE:New( "GEO Spawn ME")

-- GROUPS Armoured ****

BlueArmouredTeamEast = GROUP:FindByName("GEO Armoured Team #1")
BlueArmouredTeamEast:InitZone( BlueSpawnEast )
BlueArmouredTeamEast:InitRandomizePositionZone( true )
BlueArmouredTeamEast:HandleEvent( EVENTS.Dead )
function BlueArmouredTeamEast:OnEventDead( EventData )
  self:E( { "Size ", Size = BlueArmouredTeamEast:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
  if BlueArmouredTeamEast:GetSize() == 1 then
    BlueArmouredTeamEast:Respawn()
  end
end

BlueArmouredTeamMidEast = GROUP:FindByName("GEO Armoured Team #2")
BlueArmouredTeamMidEast:InitZone( BlueSpawnMidEast )
BlueArmouredTeamMidEast:InitRandomizePositionZone( true )
BlueArmouredTeamMidEast:HandleEvent( EVENTS.Dead )
function BlueArmouredTeamMidEast:OnEventDead( EventData )
  self:E( { "Size ", Size = BlueArmouredTeamMidEast:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
  if BlueArmouredTeamMidEast:GetSize() == 1 then
    BlueArmouredTeamMidEast:Respawn()
  end
end

BlueArmouredTeamMidWest = GROUP:FindByName("GEO Armoured Team #3")
BlueArmouredTeamMidWest:InitZone( BlueSpawnMidWest )
BlueArmouredTeamMidWest:InitRandomizePositionZone( true )
BlueArmouredTeamMidWest:HandleEvent( EVENTS.Dead )
function BlueArmouredTeamMidWest:OnEventDead( EventData )
  self:E( { "Size ", Size = BlueArmouredTeamMidWest:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
    if BlueArmouredTeamMidWest:GetSize() == 1 then
    BlueArmouredTeamMidWest:Respawn()
  end
end

BlueArmouredTeamWest = GROUP:FindByName("GEO Armoured Team #4")
BlueArmouredTeamWest:InitZone( BlueSpawnWest )
BlueArmouredTeamWest:InitRandomizePositionZone( true )
BlueArmouredTeamWest:HandleEvent( EVENTS.Dead )
function BlueArmouredTeamWest:OnEventDead( EventData )
  self:E( { "Size ", Size = BlueArmouredTeamWest:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
  if BlueArmouredTeamWest:GetSize() == 1 then
    BlueArmouredTeamWest:Respawn()
  end
end

-- GROUPS Infantry ****

BlueInfantryTeamMidEast = GROUP:FindByName("GEO Infantry Team #2")
BlueInfantryTeamMidEast:InitZone( BlueSpawnMidEast )
BlueInfantryTeamMidEast:InitRandomizePositionZone( true )
BlueInfantryTeamMidEast:HandleEvent( EVENTS.Dead )
function BlueInfantryTeamMidEast:OnEventDead( EventData )
  self:E( { "Size ", Size = BlueInfantryTeamMidEast:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
  if BlueInfantryTeamMidEast:GetSize() == 1 then
    BlueInfantryTeamMidEast:Respawn()
  end
end

BlueInfantryTeamMidWest = GROUP:FindByName("GEO Infantry Team #3")
BlueInfantryTeamMidWest:InitZone( BlueSpawnMidWest )
BlueInfantryTeamMidWest:InitRandomizePositionZone( true )
BlueInfantryTeamMidWest:HandleEvent( EVENTS.Dead )
function BlueInfantryTeamMidWest:OnEventDead( EventData )
  self:E( { "Size ", Size = BlueInfantryTeamMidWest:GetSize() } )
  -- When the last vehicle of the group is declared dead, respawn the group.
    if BlueInfantryTeamMidWest:GetSize() == 1 then
    BlueInfantryTeamMidWest:Respawn()
  end
end

-- RED SIDE **************************************************************************************

RedDetectionSetGroup = SET_GROUP:New()
RedDetectionSetGroup:FilterPrefixes( { "Red EWR Beslan", "Red EWR Gudauta", "Red EWR AWACS" } )
RedDetectionSetGroup:FilterStart()

RedDetectionArea = DETECTION_AREAS:New( RedDetectionSetGroup, 30000 )

RedDispatcher = AI_A2A_DISPATCHER:New( RedDetectionArea )
RedDispatcher:SetTacticalDisplay( false ) -- set to true for debugging
RedDispatcher:SetEngageRadius( 80000 )
RedDispatcher:SetDisengageRadius( 100000 )
RedDispatcher:SetBorderZone( RedBorder )

-- RUS Mozdok SQUADRON & CAP *******************************************

MozdokSqdn = "RUS Mozdok"
RedDispatcher:SetSquadron( MozdokSqdn, AIRBASE.Caucasus.Mozdok, { "RUS CAP Mozdok Mig-23", "RUS CAP Mozdok Mig-25" }, 32 )
RedDispatcher:SetSquadronOverhead( MozdokSqdn, 1 )
RedDispatcher:SetSquadronGrouping( MozdokSqdn, 2 )
RedDispatcher:SetSquadronFuelThreshold( MozdokSqdn, 0.30 )
RedDispatcher:SetSquadronLandingNearAirbase( MozdokSqdn )

RedMozdokCAPRoute = ZONE_POLYGON:NewFromGroupName( "RUS Mozdok CAP Route")
RedDispatcher:SetSquadronCap( MozdokSqdn, RedMozdokCAPRoute, 4000, 8000, 850, 950, redMinInterceptSpeed, redMaxInterceptSpeed, BarometricAltitude )
RedDispatcher:SetSquadronCapInterval( MozdokSqdn, 3, 300, 600, 1 )
RedDispatcher:SetSquadronGci( MozdokSqdn, redMinInterceptSpeed, redMaxInterceptSpeed )

-- ABK Gudauta SQUADRON & CAP *******************************************

GudautaSqdn = "ABK Gudauta"
RedDispatcher:SetSquadron( GudautaSqdn, AIRBASE.Caucasus.Sukhumi_Babushara, { "ABK CAP Gudauta Mig-21" }, 16 )
RedDispatcher:SetSquadronOverhead( GudautaSqdn, 1 )
RedDispatcher:SetSquadronGrouping( GudautaSqdn, 2 )
RedDispatcher:SetSquadronFuelThreshold( GudautaSqdn, 0.30 )
RedDispatcher:SetSquadronLandingNearAirbase( GudautaSqdn )

RedGudautaCAPRoute = ZONE_POLYGON:NewFromGroupName( "ABK Gudauta CAP Route")
RedDispatcher:SetSquadronCap( GudautaSqdn, RedGudautaCAPRoute, 1500, 6000, 850, 950, redMinInterceptSpeed, redMaxInterceptSpeed, BarometricAltitude )
RedDispatcher:SetSquadronCapInterval( GudautaSqdn, 1, 300, 600, 1 )

-- RED SIDE CAS AI Mi-24 **************************************************************************************

RedEngagementZoneMi24 = ZONE:New( "Conflict Zone Red Mi-24" )
RedPatrolZoneMi24 = ZONE:New( "Red CAS Mi-24 Loiter" )

RedAICasZoneMi24 = AI_CAS_ZONE:New( RedPatrolZoneMi24, 500, 1000, 500, 600, RedEngagementZoneMi24, "RADIO" )
RedAICasZoneMi24:ManageDamage(0.8)
RedAICasZoneMi24:ManageFuel(0.1, 0)

-- Check every 60 seconds whether the Targets have been eliminated.
-- When the trigger completed has been fired, the Plane will go back to the Patrol Zone.
Check, CheckScheduleID = SCHEDULER:New(nil,
  function()
    if BlueArmouredTeamEast:IsAlive() or BlueArmouredTeamMidEast:IsAlive() or BlueArmouredTeamMidWest:IsAlive() then
    	totalTargets = BlueArmouredTeamEast:GetSize() + BlueArmouredTeamMidEast:GetSize() + BlueArmouredTeamMidWest:GetSize()
      BASE:E( "RED CAS Mission Mi-24: " .. totalTargets .. " targets left to be destroyed.")
    else
      BASE:E( "RED CAS Mission Mi-24: The required targets are destroyed." )
      RedAICasZoneMi24:__Accomplish( 1 ) -- Now they should fly back to the patrolzone and patrol.
    end
  end, {}, 20, 60, 0.2 )

-- When the targets in the zone are destroyed, (see scheduled function), the planes will return home ...
function RedAICasZoneMi24:OnAfterAccomplish( Controllable, From, Event, To )
  BASE:E( "RED CAS Mission Mi-24: Sending the Mi-24 back to base." )
  Check:Stop( CheckScheduleID )
  RedAICasZoneMi24:__RTB( 1 )
end

CASAbkSpawnMi24 = SPAWN
  :New( "ABK Mi-24" )
  :InitLimit(2,0)
  :InitRepeatOnEngineShutDown()
  :SpawnScheduled(60,0)
  :OnSpawnGroup(
    --- @param Wrapper.Group#GROUP SpawnGroup
    function( SpawnGroup )
      RedAICasZoneMi24:SetControllable( SpawnGroup )
      RedAICasZoneMi24:__Start( 1 )
      RedAICasZoneMi24:__Engage( 120 )
    end
  )

-- RED SIDE CAS AI Su-25 **************************************************************************************

RedEngagementZoneSu25 = ZONE:New( "Conflict Zone Red Su-25" )
RedPatrolZoneSu25 = ZONE:New( "Red CAS Su-25 Loiter" )

RedAICasZoneSu25 = AI_CAS_ZONE:New( RedPatrolZoneSu25, 500, 1000, 500, 600, RedEngagementZoneSu25, "RADIO" )
RedAICasZoneSu25:ManageDamage(0.8)
RedAICasZoneSu25:ManageFuel(0.3, 0)

-- Check every 60 seconds whether the Targets have been eliminated.
-- When the trigger completed has been fired, the Plane will go back to the Patrol Zone.
Check, CheckScheduleID = SCHEDULER:New(nil,
  function()
    if BlueArmouredTeamMidWest:IsAlive() or BlueArmouredTeamWest:IsAlive() then
    	totalTargets = BlueArmouredTeamMidWest:GetSize() + BlueArmouredTeamWest:GetSize()
      BASE:E( "RED CAS Mission Su-25: " .. totalTargets .. " targets left to be destroyed.")
    else
      BASE:E( "RED CAS Mission Su-25: The required targets are destroyed." )
      RedAICasZoneSu25:__Accomplish( 1 ) -- Now they should fly back to the patrolzone and patrol.
    end
  end, {}, 20, 60, 0.2 )

-- When the targets in the zone are destroyed, (see scheduled function), the planes will return home ...
function RedAICasZoneSu25:OnAfterAccomplish( Controllable, From, Event, To )
  BASE:E( "RED CAS Mission Su-25: Sending the Su-25 back to base." )
  Check:Stop( CheckScheduleID )
  RedAICasZoneSu25:__RTB( 1 )
end

CASAbkSpawnSu25 = SPAWN
  :New( "ABK Su-25" )
  :InitLimit(2,0)
  :InitRepeatOnEngineShutDown()
  :SpawnScheduled(60,0)
  :OnSpawnGroup(
    --- @param Wrapper.Group#GROUP SpawnGroup
    function( SpawnGroup )
      RedAICasZoneSu25:SetControllable( SpawnGroup )
      RedAICasZoneSu25:__Start( 1 )
      RedAICasZoneSu25:__Engage( 120 )
    end
  )

-- BLUE SIDE CAP AI **************************************************************************************

BlueDetectionSetGroup = SET_GROUP:New()
BlueDetectionSetGroup:FilterPrefixes( { "Blue EWR Batumi", "Blue EWR Vaziani" } )
BlueDetectionSetGroup:FilterStart()

BlueDetectionArea = DETECTION_AREAS:New( BlueDetectionSetGroup, 30000 )

BlueDispatcher = AI_A2A_DISPATCHER:New( BlueDetectionArea )
BlueDispatcher:SetTacticalDisplay( false ) -- set to true for debugging
BlueDispatcher:SetEngageRadius( 80000 )
BlueDispatcher:SetDisengageRadius( 100000 )
BlueDispatcher:SetBorderZone( BlueBorder)

BlueBatumiCAPRoute = ZONE_POLYGON:NewFromGroupName( "Blue Batumi CAP Route")

-- US SQUADRON & CAP *******************************************
UsSqdn = "US Batumi"
BlueDispatcher:SetSquadron( UsSqdn, AIRBASE.Caucasus.Batumi, { "US CAP F-16" }, 8 )
BlueDispatcher:SetSquadronOverhead( UsSqdn, 1 )
BlueDispatcher:SetSquadronGrouping( UsSqdn, 2 )
BlueDispatcher:SetSquadronFuelThreshold( UsSqdn, 0.30 )
BlueDispatcher:SetSquadronLandingNearAirbase( UsSqdn )

BlueDispatcher:SetSquadronCap( UsSqdn, BlueBatumiCAPRoute, 4000, 8000, 850, 950, 1000, 1200, BarometricAltitude )
BlueDispatcher:SetSquadronCapInterval( UsSqdn, 1, 180, 300, 1 )

-- BLUE SIDE CAS AI Su-25 EAST **************************************************************************************

BlueCASEngagementZoneEast = ZONE:New( "Conflict Zone E" )
BluePatrolZoneEast = ZONE:New( "Blue CAS Loiter E" )

BlueAICasZoneEast = AI_CAS_ZONE:New( BluePatrolZoneEast, 500, 1000, 500, 600, BlueCASEngagementZoneEast, "RADIO" )
BlueAICasZoneEast:ManageDamage(0.8)
BlueAICasZoneEast:ManageFuel(0.3, 0)

-- Check every 60 seconds whether the Targets have been eliminated.
-- When the trigger completed has been fired, the Plane will go back to the Patrol Zone.
Check, CheckScheduleID = SCHEDULER:New(nil,
  function()
    if RedArmouredTeamEast:IsAlive() or RedArmouredTeamMidEast:IsAlive() then
    	totalTargets = RedArmouredTeamEast:GetSize() + RedArmouredTeamMidEast:GetSize()
      BASE:E( "BLUE CAS Mission East: " .. totalTargets .. " targets left to be destroyed.")
    else
      BASE:E( "BLUE CAS Missionm East: The required targets are destroyed." )
      BlueAICasZoneEast:__Accomplish( 1 ) -- Now they should fly back to the patrolzone and patrol.
    end
  end, {}, 20, 60, 0.2 )

-- When the targets in the zone are destroyed, (see scheduled function), the planes will return home ...
function BlueAICasZoneEast:OnAfterAccomplish( Controllable, From, Event, To )
  BASE:E( "BLUE CAS Mission East: Sending the Su-25 back to base." )
  Check:Stop( CheckScheduleID )
  BlueAICasZoneEast:__RTB( 1 )
end

CASGeoSpawnEast = SPAWN
  :New( "GEO CAS Su-25" )
  :InitLimit(2,0)
  :InitRepeatOnEngineShutDown()
  :SpawnScheduled(60,0)
  :OnSpawnGroup(
    --- @param Wrapper.Group#GROUP SpawnGroup
    function( SpawnGroup )
      BlueAICasZoneEast:SetControllable( SpawnGroup )
      BlueAICasZoneEast:__Start( 1 )
      BlueAICasZoneEast:__Engage( 120 )
    end
  )

-- BLUE SIDE CAS AI Mi-24 WEST **************************************************************************************

BlueCASEngagementZoneWest = ZONE:New( "Conflict Zone W" )
BluePatrolZoneWest = ZONE:New( "Blue CAS Loiter W" )

BlueAICasZoneWest = AI_CAS_ZONE:New( BluePatrolZoneWest, 500, 1000, 500, 600, BlueCASEngagementZoneWest, "RADIO" )
BlueAICasZoneWest:ManageDamage(0.8)
BlueAICasZoneWest:ManageFuel(0.1, 0)

-- Check every 60 seconds whether the Targets have been eliminated.
-- When the trigger completed has been fired, the Plane will go back to the Patrol Zone.
Check, CheckScheduleID = SCHEDULER:New(nil,
  function()
    if RedArmouredTeamMidWest:IsAlive() or RedArmouredTeamWest:IsAlive() then
    	totalTargets = RedArmouredTeamMidWest:GetSize() + RedArmouredTeamWest:GetSize()
      BASE:E( "BLUE CAS Mission West: " .. totalTargets .. " targets left to be destroyed.")
    else
      BASE:E( "BLUE CAS Mission West: The required targets are destroyed." )
      BlueAICasZoneWest:__Accomplish( 1 ) -- Now they should fly back to the patrolzone and patrol.
    end
  end, {}, 20, 60, 0.2 )

-- When the targets in the zone are destroyed, (see scheduled function), the planes will return home ...
function BlueAICasZoneWest:OnAfterAccomplish( Controllable, From, Event, To )
  BASE:E( "BLUE CAS Mission West: Sending the Mi-24 back to base." )
  Check:Stop( CheckScheduleID )
  BlueAICasZoneWest:__RTB( 1 )
end

CASGeoSpawnWest = SPAWN
  :New( "GEO CAS Mi-24" )
  :InitLimit(2,0)
  :InitRepeatOnEngineShutDown()
  :SpawnScheduled(60,0)
  :OnSpawnGroup(
    --- @param Wrapper.Group#GROUP SpawnGroup
    function( SpawnGroup )
      BlueAICasZoneWest:SetControllable( SpawnGroup )
      BlueAICasZoneWest:__Start( 1 )
      BlueAICasZoneWest:__Engage( 120 )
    end
  )

-- A2A TASKING ***************************************************************************************

USHQ = GROUP:FindByName( "Blue HQ", "Zeus HQ" )
CommandCenter = COMMANDCENTER:New(USHQ, "Zeus")

Scoring = SCORING:New("Operation Dauntless Resolution")

-- Air to Air Tasking *******************************************
InterceptMission = MISSION
  :New( CommandCenter, "Intercept", "", "Intercept", coalition.side.BLUE )
  :AddScoring( Scoring )

PlayerGroup = SET_GROUP:New():FilterCoalitions( blueCoalition ):FilterPrefixes( "US Player" ):FilterStart()

-- Setup the A2A dispatcher, and initialize it.
InterceptDispatcher = TASK_A2A_DISPATCHER:New( InterceptMission, PlayerGroup, BlueDetectionArea )
InterceptDispatcher:SetRefreshTimeInterval( 30 )

 --- @param #TaskDispatcher self
 -- @param #string From Contains the name of the state from where the Event was triggered.
 -- @param #string Event Contains the name of the event that was triggered. In this case Assign.
 -- @param #string To Contains the name of the state that will be transitioned to.
 -- @param Tasking.Task_A2A#TASK_A2A Task The Task object, which is any derived object from TASK_A2A.
 -- @param Wrapper.Unit#UNIT TaskUnit The Unit or Client that contains the Player.
 -- @param #string PlayerName The name of the Player that joined the TaskUnit.
 function InterceptDispatcher:OnAfterAssign( From, Event, To, Task, TaskUnit, PlayerName )
   Task:SetScoreOnProgress( PlayerName, 20, TaskUnit )
   Task:SetScoreOnSuccess( PlayerName, 100, TaskUnit )
   Task:SetScoreOnFail( PlayerName, -5, TaskUnit )
 end

 -- A2G TASKING ***************************************************************************************

CasBaiMission = MISSION
	:New( CommandCenter, "SEAD/BAI/CAS", "", "SEAD/BAI/CAS", coalition.side.BLUE )
	:AddScoring( Scoring )

 -- Define the RecceSet that will detect the enemy.
USFacSet = SET_GROUP:New():FilterCoalitions( blueCoalition ):FilterPrefixes( "US FAC" ):FilterStart()
-- Setup the detection.
-- UsFacDetectionUnits = DETECTION_UNITS:New( USFacSet )
UsFacDetectionUnits = DETECTION_AREAS:New( USFacSet, 1000 )
UsFacDetectionUnits:FilterCategories({Unit.Category.AIRPLANE,Unit.Category.HELICOPTER})
UsFacDetectionUnits:__Start( 5 )

-- Setup Designation for the AttackSet.
UsFacDetectionUnitsDesignator = DESIGNATE:New( CommandCenter, UsFacDetectionUnits, PlayerGroup )
-- Generate the random laser codes.
UsFacDetectionUnitsDesignator:GenerateLaserCodes()
-- The Player has a predefined 1666 laser code in the mission editor
UsFacDetectionUnitsDesignator:AddMenuLaserCode( 1666, "*** USE 1666 ***" )
UsFacDetectionUnitsDesignator:SetThreatLevelPrioritization( true )

CasBaiDispatcher = TASK_A2G_DISPATCHER:New( CasBaiMission, PlayerGroup, UsFacDetectionUnits )
CasBaiDispatcher:SetRefreshTimeInterval( 30 )

 --- @param #TaskInterceptDispatcher self
 -- @param #string From Contains the name of the state from where the Event was triggered.
 -- @param #string Event Contains the name of the event that was triggered. In this case Assign.
 -- @param #string To Contains the name of the state that will be transitioned to.
 -- @param Tasking.Task_A2A#TASK_A2A Task The Task object, which is any derived object from TASK_A2A.
 -- @param Wrapper.Unit#UNIT TaskUnit The Unit or Client that contains the Player.
 -- @param #string PlayerName The name of the Player that joined the TaskUnit.
 function CasBaiDispatcher:OnAfterAssign( From, Event, To, Task, TaskUnit, PlayerName )
   Task:SetScoreOnProgress( PlayerName, 20, TaskUnit )
   Task:SetScoreOnSuccess( PlayerName, 100, TaskUnit )
   Task:SetScoreOnFail( PlayerName, -5, TaskUnit )
 end

collectgarbage()
BASE:E( "Collected garbage" )